const net = require('net');


    const port = 587;
    const remoteHost = "localhost";


    var MAILFROM = '';
    exports.setMAILFROM = function(mf) {MAILFROM = mf};
    var recipientsArr = [];
    exports.setRecipientsArr = function(r) {recipientsArr = r};
    var From = '';
    exports.setFrom = function(f) {From = f};
    var To = '';
    exports.setTo = function(T) {To = T};
    var Cc = '';
    exports.setCc = function(c) {Cc = c};
    var Bcc = '';
    exports.setBcc = function(b) {Bcc = b};
    var $Date;
    var Subject = '';
    exports.setSubject = function(s) {Subject = s};
    var Body = '';
    exports.setBody = function(bo) {Body = bo};


    function currentDate()
        {
            var dteObj = new Date();

            var week = ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"];
            var mYear = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"];
   
            var serverDateStr;

            var year = dteObj.getFullYear();
            var hr = dteObj.getHours();
            var mn = dteObj.getMinutes();
            var sc = dteObj.getSeconds();
            if (hr < 10)
                {
                    hr = "0" + `${hr}`;
                } 
            if (mn < 10)  
                {
                    mn = "0" + `${mn}`;
                } 
            if (sc < 10)
                {
                    sc = "0" + `${sc}`;
                } 

            serverDateStr = week[dteObj.getDay()] + ", " + dteObj.getDate() + " " + mYear[dteObj.getMonth()] + " " + year + " " + hr + ":" + mn + ":" + sc;

            return serverDateStr + ' -0000';
        }

    function textWrap(msgVal)
        {
            msgVal = msgVal.replace(/^\s+/, ""); //remove leading whitespace characters
            arr = msgVal.split(/\r\n|\n/);  //split at new lines
            str = ""; //final string
            for (item of arr)
               {//form the final string inserting \n
                    item = item.replace(/^\s+/, ""); //remove leading whitespace characters
                    if (item.length <= 70)
                        {
                            str = str + item +"\n";
                        }
                    else
                       {//get up to 70 characters without last broken word, ending them with \n
                            while (item.length >0)
                                {
                                    if (item.length >= 70)
                                        {
                                            str1 = item.substring(0, 70);
                                            str2 = str1.replace(/\s\S*$/, "");
                                            str = str + str2 + '\n';
                                            if (str1.length == 70)
                                                {
                                                    item = item.replace(str2, ""); 
                                                    item = item.replace(/^\s+/, ""); //remove leading whitespace characters
                                                }
                                        }
                                    else
                                        {
                                            break;
                                        }
                                }
                            item = item.replace(/^\s+/, ""); //remove leading whitespace characters
                            str = str + item + '\n';
                       }
                }
            return str;
        }

    var error;
    var errMsg = "Error occured. Mail was not sent!";
    function lengthError(field, socket)
        {
            error = "The " + field + " field length is more than 70 characers. Mail not sent!"; 
            errorClose(socket);
        }

    function errorClose(socket)
        {
            error = errMsg;
            socket.write('QUIT\n');
            socket.destroy();
        }


    function sendmailM(callback)
        {
            const socket = net.createConnection(port, remoteHost);

            socket.on('error', (err) => 
               {
                    callback(err, false);
                    errorClose(socket);
                    return;
                });

            recieveCount = -1;

            socket.on('data', (data) => 
                {
                    receivedStr = data.toString();

                    recieveCount += 1;

                    if (recieveCount == 0)
                        {
                            if (receivedStr.search(/^\s*220/) == -1)
                                {
                                    error = errMsg;
                                    callback(errMsg, true);
                                    errorClose(socket);
                                    return;
                                }
                            else
                                {
                                    socket.write('HELO\n');
                                }
                        }

                    if (recieveCount == 1)
                        {
                            if ((receivedStr.search(/^\s*250/) == -1)||(MAILFROM.length > 70)||(MAILFROM.length == 0))
                                {
                                    error = errMsg;
                                    callback(errMsg, true);
                                    errorClose(socket);
                                    return;
                                }
                            else
                                {
                                    MAILFROM = MAILFROM.replace(/^\s*|\s*$/g, "");
                                    MAILFROM = "MAIL FROM: " + MAILFROM + '\n';   
                                    socket.write(MAILFROM);
                                }
                        }

                    if (recieveCount == 2)
                        {
                            if ((receivedStr.search(/^\s*250/) == -1)||(recipientsArr.length == 0))
                                {
                                    error = errMsg;
                                    callback(errMsg, true);
                                    errorClose(socket);
                                    return;
                                }
                            else
                                {
                                    for(item of recipientsArr)
                                        {
                                            item = item.replace(/^\s*|\s*$/g, "");
                                            RCPTTO = 'RCPT TO: ' + item + '\n'; 
                                            socket.write(RCPTTO);
                                        }
                                }
                        }

                    if (recieveCount == 3)
                        {
                            if (error == undefined)
                                {
                                    if (receivedStr.search(/^\s*250/) == -1)
                                        {
                                            errorClose(socket);
                                            callback(errMsg, true);
                                            errorClose(socket);
                                            return;
                                        }
                                    else
                                        {
                                            socket.write('DATA\n');
                                        }
                                }
                        }

                    if (recieveCount == 4)
                        {
                            if (error == undefined)
                                {
                                    if (receivedStr.search(/^\s*354/) == -1)
                                        errorClose(socket);
  
                                    //form data
                                    //header
                                    if ((From.length <= 70)&&(From.length > 0))
                                        {
                                            From = 'From: ' + From + '\n' ;
                                        }
                                    else
                                        {
                                            lengthError('From', socket);
                                        }
                                    if ((To.length <= 70)&&(To.length > 0))
                                        {
                                            To = 'To: ' + To + '\n' ;
                                        }
                                    else
                                        {
                                            To = '';
                                        }
                                    if ((Cc.length <= 70)&&(Cc.length > 0))
                                        {
                                            Cc = 'Cc: ' + Cc + '\n' ;
                                        }
                                    else
                                        {
                                            Cc = '';
                                        }
                                    if ((Bcc.length <= 70)&&(Bcc.length > 0))
                                        {
                                            Bcc = 'Bcc: ' + Bcc + '\n' ;
                                        }
                                    else
                                        {
                                            BCC = '';
                                        }
                                    Date = 'Date: ' + currentDate() + '\n' ;
                                    if ((Subject.length <= 70)&&(Subject.length > 0))
                                        {
                                            Subject = 'Subject: ' + Subject + '\n' ;
                                        }
                                    else
                                        {
                                            lengthError('Subject', socket);
                                        }
                                    if (Body == '')
                                        {
                                           lengthError('Body', socket);
                                        }
    
                                    var blank_line = '\n';
        
                                    var DATA = From + 'To: ';
                                    var recipintsStr = ''; 
                                    for(i=0; i<recipientsArr.length; ++i)
                                        {
                                            if (recipientsArr.length > (i+1))
                                                {
                                                    recipintsStr += recipientsArr[i] + ',';
                                                }
                                            else
                                                {
                                                    recipintsStr += recipientsArr[i];
                                                }
                                        }
                                    recipintsStr = recipintsStr + '\n';
                                    Body = textWrap(Body); 
                                    DATA = DATA + recipintsStr + Cc + Bcc + Date + Subject + blank_line + Body + '.\n';
  
                                    if (error == undefined)
                                        {
                                            socket.write(DATA);
                                        }
                                }
                        }
  
                    if (recieveCount == 5)
                        {
                            if (receivedStr.search(/^\s*250/) == -1)
                                {
                                    errMsg = "Error: Not sure if message was sent.";
                                    callback(errMsg, true);
                                    errorClose(socket);
                                    return;
                                }
                            else
                               {
                                   callback(error, true);
                                   socket.write('QUIT\n');
                                   recieveCount = 6;
                               }
                        }

                    if (recieveCount == 6)
                        {
                            socket.destroy();
                        }


                });

        }

    exports.sendmail = sendmailM;


